# $Revision: 1650 $
# $Date: 2012-04-20 00:18:17 $

CREATE TABLE IF NOT EXISTS rtGroupSharefile (
  fileName varchar(256) NOT NULL COMMENT '文件名',
  fileSize int(11) NOT NULL COMMENT '文件大小',
  created varchar(45) NOT NULL COMMENT '上传着',
  createDate datetime NOT NULL COMMENT '上传时间',
  room_id varchar(150) DEFAULT NULL COMMENT '群组ID',
  sid varchar(45) NOT NULL COMMENT 'session ID',
  PRIMARY KEY (sid),
  INDEX rtGroupSharefile_roomId_idx (room_id)
)  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS rtElectronAlert (
  id BIGINT NOT NULL AUTO_INCREMENT COMMENT '电子公告ID',
  title varchar(200) NOT NULL COMMENT '电子公告标题',
  content text NOT NULL COMMENT '电子公告内容',
  create_date datetime NOT NULL COMMENT '电子公告创建并发送日期',
  created varchar(45) NOT NULL COMMENT '电子公告创建人',
  companyId bigint(20) default 0 COMMENT '所属分司',
  PRIMARY KEY (id),
  INDEX rtElectronAlert_companyId_idx (companyId)
)  DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS rtElectronReceivers (
  electron_id BIGINT NOT NULL COMMENT '电子公告ID',
  receiver varchar(45) NULL COMMENT '接收者',
  departmentId BIGINT null comment '接收部门',
  isread char(1) DEFAULT '0' comment '是否已阅读 0 是未阅读，1是已阅读',
  read_date datetime DEFAULT NULL COMMENT '电子公告阅读日期',
  isreceived char(1) default '0'  comment '是否已经接收',
  companyId bigint(20) default 0 COMMENT '所属分司',
  PRIMARY KEY (electron_id,receiver),
  INDEX rtElectronReceivers_electronid_idx (electron_id),
  INDEX rtElectronReceivers_receiver_idx (receiver)
)  DEFAULT CHARSET=utf8;

UPDATE ofVersion SET version=23 where name='openfire';


