# $Revision: 1650 $
# $Date: 2012-05-30 00:18:17 $

CREATE TABLE IF NOT EXISTS rtOutFax (
	 id bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID号',
	 subject varchar(200) NOT NULL COMMENT '传真主题',
	 remark varchar(1000) NULL COMMENT '备注',
	 pageSize int NOT NULL COMMENT '页数',
	 sender varchar(45) NOT NULL COMMENT '发送者',
	 sendDate datetime NULL COMMENT '发送时间 ，如果为NULL表示即发送',
	 sid varchar(45) NOT NULL COMMENT '文件sid',
     fileName varchar(256) NOT NULL COMMENT '文件名',
     fileSize bigint(20) NOT NULL COMMENT '文件大小',
	 createDate datetime NOT NULL COMMENT '创建日期',
	 PRIMARY KEY (id)
) DEFAULT CHARSET=utf8 COMMENT '发送传真';


CREATE TABLE IF NOT EXISTS rtFaxReceiver(
	faxId bigint(20) NOT NULL COMMENT '传真ID',
	receiverName varchar(45) NOT NULL COMMENT '接收者姓名，如果没有姓名则为号码',
	receiverNumber varchar(20) NOT NULL COMMENT '接收者号码',
	status char(1) NOT NULL DEFAULT '0' COMMENT '状态，0表示发送失败，1表示发送成功',
	PRIMARY KEY (faxId,receiverNumber)
) DEFAULT CHARSET=utf8 COMMENT '传真的接收者';

CREATE TABLE IF NOT EXISTS rtInFax(
	id bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID号',
	sender varchar(45) NOT NULL COMMENT '发送者号码',
	subject varchar(200) NULL COMMENT '传真主题', 
	pageSize int NULL COMMENT '页数',
	receiver varchar(45) NOT NULL COMMENT '接收者bareJID',
	receiverNumber varchar(20) NOT NULL COMMENT '接收号码',
	fileName varchar(256) NOT NULL COMMENT '文件名',
	fileSize bigint NOT NULL COMMENT '文件大小',
	sid varchar(256) NOT NULL COMMENT 'sid',
	createDate datetime NOT NULL COMMENT '创建日期',
	status char(1) NOT NULL DEFAULT '0' COMMENT '是否删除，0未删除，1表示删除',
	isreceive char(1) NOT NULL DEFAULT '0' COMMENT '是否已经接收',
	isread char(1) NOT NULL DEFAULT '0' COMMENT '是否已经读取',
	PRIMARY KEY (id)
) DEFAULT CHARSET=utf8 COMMENT '接收传真';

CREATE TABLE IF NOT EXISTS rtFaxForward(
	inFaxId bigint(20) NOT NULL COMMENT '接收传真的ID',
	sender varchar(45) NOT NULL COMMENT '发送者bareJID',
	receiver varchar(45) NOT NULL COMMENT '接收者bareJID',
	isreceive char(1) NOT NULL DEFAULT '0' COMMENT '是否已经接收',
	isread char(1) NOT NULL DEFAULT '0' COMMENT '是否已经读取',
	createDate datetime NOT NULL COMMENT '创建日期',
	PRIMARY KEY (inFaxId,receiver)
) DEFAULT CHARSET=utf8 COMMENT '转发记录';

UPDATE ofVersion SET version = 25 WHERE name = 'openfire';



